require 'langscan/_common'

module LangScan
  module EmacsLisp
    def lang_name
      "Emacs Lisp"
    end
    module_function :lang_name

    def lang_abbrev
      "elisp"
    end
    module_function :lang_abbrev

    def extnames
      [".el"]
    end
    module_function :extnames

    Pattern = [[:comment, ";.*"],
               [:string, "\"\""],
               [:string, "\"", "[^\\\\]\""],
               [:integer, "\\d+"],
               [:ident, "[-\\w]+"]]

    Types = []

    Keywords = %w(
      defun defvar defmacro defgroup defcustom
      lambda prog1 prog2 progn let if when unless cond catch throw require
    )

    def scan (input, &block)
      scanner = LangScanner.new(Pattern, Types, Keywords)
      scanner.scan(input, &block)
    end
    module_function :scan
  end
end

if LangScan.respond_to?(:register)
  LangScan.register(LangScan::EmacsLisp)
end
