// -*- mode: c -*-
var highlightColor = "#ffff88";
var backgroundColor = "white";
var lineCache;
var idCache;
var previousId;
var previousLineNo;

function initCache () {
    spanCache = document.getElementsByTagName("span");
    lineCache = new Array();
    idCache = new Array();

    for (i in spanCache) {
	e = spanCache[i];

	// build lineCache
	if (e.className == "line") {
	  lineCache.push(e, e.title);
	}

	// build idCache
        id = e.id;
	if (id) {
	  if (!idCache[id]) {
	    idCache[id] = new Array();
	  }
	  idCache[id].push(e);
	}
    }
}

function setHighlight (id, color) {
    ids = idCache[id];
    for (i in ids) {
	e = ids[i];
        e.style.backgroundColor = color;
    }
}

function clearHighlight () {
    if (previousId)
        setHighlight(previousId, backgroundColor);
}

function highlight (id) {
    clearHighlight();
    setHighlight(id, highlightColor)
    previousId = id;
    return true;
}

function grep (string) {
    try {
        pattern = new RegExp(string, "i");
	len = lineCache.length;
        for (i = 0; i < len; i += 2) {
            e = lineCache[i];
            title = lineCache[i + 1];
            if (title.match(pattern)) {
                e.style.display = "inline";
            } else {
                e.style.display = "none";
            }
        }
    } catch (e) {
        // Ignore errors of invalid regular expressions.
    }
}

function onLineNoClick (e) {
    if (previousLineNo)
        previousLineNo.style.backgroundColor = backgroundColor;
    e.style.backgroundColor = highlightColor;
    previousLineNo = e;
    len = lineCache.length;
    for (i = 0; i < len; i += 2) {
	e = lineCache[i];
        e.style.display = "inline";
    }
}

function displayAdvancedSearchForm () {
    forms = document.getElementsByTagName("form");
    for (i in forms) {
        e = forms[i];
        if (e.className == "advanced-search") {
	    e.style.display = "inline";
        }
    }
}

function passQuery (e) {
    q = document.getElementsByName("q")[0].value;
    if (q) {
        e.href += "?q=" + encodeURIComponent(q);
    }
    return true;
}
